  // save context and get return address

  // Disable interrupts
  OldSR := SR;
  SR    := SR or $E0;
  
  
  // Save Context
  
  asm
    ; Save W0 and W1 (used below)
    mov  W0, CRTOS_TmpRegs               ; save W0
    mov  W1, CRTOS_TmpRegs + 2           ; save W1
    
    ; save the return address (PCH and PCL)
    mov W15, W0                          ; StackPtr_ := ^word(W15);
    dec W0                               ; dec(StackPtr_);
    dec W0
    mov #lo_addr(CRTOS_TmpRegs), W1      ; temporary registers
    add #36, W1
    mov [W0--], [W1++]                   ; TmpPCH := StackPtr_^; dec (StackPtr_);
    mov [W0], [W1]                       ; TmpPCL := StackPtr_^;
  end;
  Save_Context; // save the rest of the context and copy it to the TaskData

  // Enable Interrupts
  SR := OldSR;